/*++

Copyright (c) Sydus.

Module:

    SelectorRegistry.h

Authors:

    Sharvil Nanavati (sharvil) 2006-07-29

--*/

#pragma once

#include "base.h"
#include "Selector.h"

class SelectorRegistry : public NonCopyable
{
	public:
		static SelectorRegistry & Instance();
		~SelectorRegistry();

		bool HasSelector(const Selector * selector) const;

	private:
		friend class Selector;
		SelectorRegistry();

		void Register(const Selector & selector);
		void Unregister(const Selector & selector);

		typedef std::set <const Selector *> SelectorSet;
		SelectorSet iSelectors;
};
