/*++

Copyright (c) Sydus.

Module:

    TcpServer.h

Authors:

    Sharvil Nanavati (sharvil) 2005-08-25

--*/

#pragma once

#include "base.h"
#include "ServerSocket.h"

class TcpClient;
class InetAddress;

class TcpServer : public ServerSocket
{
public:
	TcpServer();
	virtual ~TcpServer();
	
	virtual TcpClient * Accept();
	void Bind(uint16 port);
	void Bind(const InetAddress & host, uint16 port);
protected:
	/**
	 * Provides a mechanism by which an inheritor can reimplement
	 * Accept() without need to include ISocketImplementation itself
	 */
	virtual ISocketImplementation* SocketAccept();
};
