/*++

Copyright (c) Sydus.

Module:

    StringEncoding.h

Authors:

    Sharvil Nanavati (sharvil) 2006-12-06

--*/

#ifndef STRINGENCODING_H
#define STRINGENCODING_H

#include "base.h"

class UrlEncoding : public NonCopyable
{
	public:
		static BString SerializeString(const std::string & str);
		static std::string DeserializeString(const BString & source, std::string::size_type limit = std::string::npos);
		static std::string DeserializeString(const BString & source, BString::size_type & offset, std::string::size_type limit = std::string::npos);
};

class Base64 : public NonCopyable
{
	public:
		static BString SerializeString(const std::string & str);
		static std::string DeserializeString(const BString & source, std::string::size_type limit = std::string::npos);
		static std::string DeserializeString(const BString & source, BString::size_type & offset, std::string::size_type limit = std::string::npos);
};

class Ascii : public NonCopyable
{
	public:
		static BString SerializeString(const std::string & str);
		static std::string DeserializeString(const BString & source, BString::size_type & offset, std::string::size_type limit = std::string::npos);
};

class AsciiZ : public NonCopyable
{
	public:
		static BString SerializeString(const std::string & str);
		static std::string DeserializeString(const BString & source, BString::size_type & offset, std::string::size_type limit = std::string::npos);
};

class Length8Ascii : public NonCopyable
{
	public:
		static BString SerializeString(const std::string & str);
		static std::string DeserializeString(const BString & source, BString::size_type & offset, std::string::size_type limit = std::string::npos);
};

class Length16LittleEndianAscii : public NonCopyable
{
	public:
		static BString SerializeString(const std::string & str);
		static std::string DeserializeString(const BString & source, BString::size_type & offset, std::string::size_type limit = std::string::npos);
};

#endif
